public class UE7Aufgabe11 {

	final static int GROESSE = 9;

	public static void main(String[] args) {
		int[][] feld = { 
				{ 5, 3, 0, 0, 7, 0, 0, 0, 0 },
				{ 6, 0, 0, 1, 9, 5, 0, 0, 0 }, 
				{ 0, 9, 8, 0, 0, 0, 0, 6, 0 },
				{ 8, 0, 0, 0, 6, 0, 0, 0, 3 }, 
				{ 4, 0, 0, 8, 0, 3, 0, 0, 1 },
				{ 7, 0, 0, 0, 2, 0, 0, 0, 6 }, 
				{ 0, 6, 0, 0, 0, 0, 2, 8, 0 },
				{ 0, 0, 0, 4, 1, 9, 0, 0, 5 }, 
				{ 0, 0, 0, 0, 8, 0, 0, 7, 9 } };

		print(feld);
		sudoku(feld, 0);
	}

	static void sudoku(int[][] feld, int nummer) {
		if (voll(feld)) {
			// voll? -> Loesung gefunden
			print(feld);
		} else if (nummer >= GROESSE * GROESSE) {
			// REIHEN ueberschritten -> nicht loesbar
			return;
		} else if (feld[nummer / GROESSE][nummer % GROESSE] != 0) {
			// Feld besetzt != 0 -> naechstes Feld
			sudoku(feld, nummer + 1);
		} else {

			// sonst -> alle Ziffern durchprobieren -> Backtracking
			for (int z = 1; z <= GROESSE; z++) {
				if (istMoeglich(feld, nummer / GROESSE, nummer % GROESSE, z)) {
					feld[nummer / GROESSE][nummer % GROESSE] = z;
					sudoku(feld, nummer + 1);
				}
			}
			feld[nummer / GROESSE][nummer % GROESSE] = 0;
		}

	}

	static void print(int[][] matrix) {
		for (int r = 0; r < matrix.length; r++) {
			for (int s = 0; s < matrix[r].length; s++) {
				System.out.print(matrix[r][s] + " ");
			}
			System.out.println();
		}
		System.out.println();
	}

	static boolean voll(int[][] matrix) {
		for (int r = 0; r < matrix.length; r++) {
			for (int s = 0; s < matrix[r].length; s++) {
				if (matrix[r][s] == 0) {
					return false;
				}
			}
		}
		return true;
	}

	static boolean istMoeglich(int[][] feld, int reihe, int spalte, int wert) {
		for (int i = 0; i < GROESSE; i++) {
			if (i != spalte && feld[reihe][i] == wert) {
				return false;
			}
		}
		for (int i = 0; i < GROESSE; i++) {
			if (i != reihe && feld[i][spalte] == wert) {
				return false;
			}
		}
		for (int i = reihe / 3 * 3; i < reihe / 3 * 3 + 3; i++) {
			for (int j = spalte / 3 * 3; j < spalte / 3 * 3 + 3; j++) {
				if (i != reihe && j != spalte && feld[i][j] == wert) {
					return false;
				}
			}
		}
		return true;
	}

}
