
public class UE7Aufgabe14 {

	public static void main(String[] args) {
		int[][] matrix = { { 11, 12, 13, 14 }, { 1, 2, 3, 4 }, { 8, 7, 6, 5 }, { 0, 9, 10, 15 } };
		print(matrix);
		while (!solved(matrix)) {
			int row = enterNumber("Reihe angeben", 0, 3);
			int col = enterNumber("Spalte angeben", 0, 3);
			while (!correctInput(matrix, row, col)) {
				System.out.println("Fehler! Das angegebene Feld grenzt nicht an das leere Feld!");
				row = enterNumber("Reihe angeben", 0, 3);
				col = enterNumber("Spalte angeben", 0, 3);
			}
			changeMatrix(matrix, row, col);
			print(matrix);
		}
		System.out.println("Geschafft! Herzlichen Glueckwunsch!");
	};

	static int enterNumber(String msg, int min, int max) {
		msg = msg + "(" + min + "<=zahl<=" + max + "): ";
		int input = IO.readInt(msg);
		while (input < min || input > max) {
			input = IO.readInt("Fehlerhafte Eingabe! " + msg);
		}
		return input;
	}

	static boolean correctInput(int[][] matrix, int row, int col) {
		if (row - 1 >= 0 && matrix[row - 1][col] == 0) {
			return true;
		}
		if (row + 1 < matrix.length && matrix[row + 1][col] == 0) {
			return true;
		}
		if (col - 1 >= 0 && matrix[row][col - 1] == 0) {
			return true;
		}
		if (col + 1 < matrix[row].length && matrix[row][col + 1] == 0) {
			return true;
		}
		return false;
	}

	static void changeMatrix(int[][] matrix, int row, int col) {
		int emptyRow = 0;
		int emptyCol = 0;
		main: for (int r = 0; r < matrix.length; r++) {
			for (int c = 0; c < matrix[0].length; c++) {
				if (matrix[r][c] == 0) {
					emptyRow = r;
					emptyCol = c;
					break main;
				}
			}
		}
		matrix[emptyRow][emptyCol] = matrix[row][col];
		matrix[row][col] = 0;
	}

	static boolean solved(int[][] matrix) {
		int number = 0;
		for (int r = 0; r < matrix.length; r++) {
			for (int c = 0; c < matrix[0].length; c++) {
				if (matrix[r][c] != number) {
					return false;
				}
				number = number + 1;
			}
		}
		return true;
	}

	static void print(int[][] matrix) {
		printDividerRow(matrix);
		for (int r = 0; r < matrix.length; r++) {
			System.out.print('|');
			for (int c = 0; c < matrix[0].length; c++) {
				if (matrix[r][c] == 0) {
					System.out.print("  ");
				} else if (matrix[r][c] <= 9) {
					System.out.print(" " + matrix[r][c]);
				} else {
					System.out.print(matrix[r][c]);
				}
				System.out.print('|');
			}
			System.out.println();
			printDividerRow(matrix);
		}
	}

	static void printDividerRow(int[][] matrix) {
		System.out.print('+');
		for (int c = 0; c < matrix[0].length; c++) {
			System.out.print("--+");
		}
		System.out.println();
	}

}
