public class UE7Aufgabe41 {

	final static int ANZAHL_KUGELN = 100;
	final static int ANZAHL_RUNDEN = 10;

	public static void main(String[] args) {

		// Initialisieren
		int anzahlSpieler = IO.readInt("Anzahl an Spielern: ");
		while (anzahlSpieler < 2) {
			anzahlSpieler = IO.readInt("Fehler; Anzahl an Spielern (>= 2): ");
		}

		int[] kugeln = new int[anzahlSpieler];
		int[] punkte = new int[anzahlSpieler];
		for (int i = 0; i < anzahlSpieler; i++) {
			kugeln[i] = ANZAHL_KUGELN;
			punkte[i] = 0;
		}

		// spielen
		for (int runde = 1; runde <= ANZAHL_RUNDEN; runde++) {
			System.out.println("Runde " + runde + " von " + ANZAHL_RUNDEN
					+ " Runden");

			// Spielereingaben
			int[] wegnehmen = spielzuegeVornehmen(kugeln);

			// Auswertung
			spielzuegeAuswerten(wegnehmen, punkte);

			// Zwischenstand
			System.out.println("Spielstand nach Runde " + runde + ":");
			for (int i = 0; i < anzahlSpieler; i++) {
				System.out.println("Spieler " + (i + 1) + " hat " + punkte[i]
						+ " Punkte und " + kugeln[i] + " Restkugeln");
			}
			System.out.println();
		}

		// Endstand kundgeben
		endstandAusgeben(punkte);

	}

	static int[] spielzuegeVornehmen(int[] kugeln) {
		int[] wegnehmen = new int[kugeln.length];
		for (int s = 0; s < kugeln.length; s++) {
			wegnehmen[s] = spielzug(s + 1, kugeln[s]);
			kugeln[s] -= wegnehmen[s];
		}
		return wegnehmen;
	}

	static int spielzug(int spielerNummer, int rest) {
		int anzahl = IO.readInt("Spieler " + spielerNummer
				+ ": Wie viele Kugeln von " + rest + "?");
		while (anzahl < 0 || anzahl > rest) {
			anzahl = IO.readInt("Fehlerhafte Eingabe! Spieler " + spielerNummer
					+ ": Wie viele Kugeln von " + rest + "?");
		}
		return anzahl;
	}

	static void spielzuegeAuswerten(int[] wegnehmen, int[] punkte) {
		// groesste Zahl bestimmen
		int groessteAnzahl = wegnehmen[0];
		for (int i = 1; i < wegnehmen.length; i++) {
			if (wegnehmen[i] > groessteAnzahl) {
				groessteAnzahl = wegnehmen[i];
			}
		}

		// Punkte an die Rundensieger vergeben
		for (int i = 0; i < wegnehmen.length; i++) {
			if (wegnehmen[i] == groessteAnzahl) {
				punkte[i]++;
				System.out
						.println("Spieler "
								+ (i + 1)
								+ " hat die Runde (mit) gewonnen und bekommt einen Punkt!");
			}
		}
	}

	static void endstandAusgeben(int[] punkte) {

		// Maximale Punktzahl berechnen
		int max = punkte[0];
		for (int i = 0; i < punkte.length; i++) {
			if (punkte[i] > max) {
				max = punkte[i];
			}
		}

		// Sieger bekanntgeben
		System.out.println("Endstand:");
		for (int i = 0; i < punkte.length; i++) {
			if (punkte[i] == max) {
				System.out.println("Spieler " + (i + 1)
						+ " ist der bzw. einer der Sieger des Spiels!");
			}
		}
	}

}
