// http://de.wikipedia.org/wiki/Survo_Puzzle

public class UE7Aufgabe56 {

	public static void main(String[] args) {

		int[][] matrix = { { 12, 6, 2, 10 }, { 8, 1, 5, 4 }, { 7, 9, 3, 11 } };
		int[] reihenSummen = { 30, 18, 30 };
		int[] spaltenSummen = { 27, 16, 10, 25 };

		System.out
				.println(istSurvoLoesung(matrix, reihenSummen, spaltenSummen));
	}

	// ueberprueft, ob die uebergebenen Zahlen eine korrekte Loesung eines
	// Survo-Raetsels darstellen
	// Voraussetzung: Die Parameter repraesentieren ein korrektes Survo-Raetsel,
	// d.h. die Groessen der uebergebenen Arrays sind korrekt
	static boolean istSurvoLoesung(int[][] matrix, int[] reihenSummen,
			int[] spaltenSummen) {

		if (!checkZahlen(matrix)) {
			return false;
		}

		if (!checkReihenSummen(matrix, reihenSummen)) {
			return false;
		}

		if (!checkSpaltenSummen(matrix, spaltenSummen)) {
			return false;
		}

		return true;
	}

	// liefert genau dann true, wenn gilt: Habe die Matrix matrix m Reihen und n
	// Spalten. Dann ist jede Zahl zwischen 1 und m*n genau einmal in matrix
	// enthalten.
	static boolean checkZahlen(int[][] matrix) {
		boolean[] zahlen = new boolean[matrix.length * matrix[0].length];
		for (int r = 0; r < matrix.length; r++) {
			for (int s = 0; s < matrix[r].length; s++) {
				if (matrix[r][s] < 1
						|| matrix[r][s] > matrix.length * matrix[0].length) {
					return false;
				}
				if (zahlen[matrix[r][s] - 1]) {
					return false;
				}
				zahlen[matrix[r][s] - 1] = true;
			}
		}
		return true;
	}

	// liefert genau dann true, wenn fuer alle Reihen i (0..AnzahlReihen-1) der
	// Matrix gilt:
	// die Summe der Zahlen der Reihe i der Matrix ist gleich reihenSummen[i]
	static boolean checkReihenSummen(int[][] matrix, int[] reihenSummen) {
		for (int r = 0; r < matrix.length; r++) {
			int summe = 0;
			for (int s = 0; s < matrix[r].length; s++) {
				summe += matrix[r][s];
			}
			if (summe != reihenSummen[r]) {
				return false;
			}
		}
		return true;
	}

	// liefert genau dann true, wenn fuer alle Spalten i (0..AnzahlSpalten-1)
	// der Matrix gilt:
	// die Summe der Zahlen der Spalte i der Matrix ist gleich spaltenSummen[i]
	static boolean checkSpaltenSummen(int[][] matrix, int[] spaltenSummen) {
		for (int s = 0; s < matrix[0].length; s++) {
			int summe = 0;
			for (int r = 0; r < matrix.length; r++) {
				summe += matrix[r][s];
			}
			if (summe != spaltenSummen[s]) {
				return false;
			}
		}
		return true;
	}

}
